﻿// 彗星通行证访问接口

/* 通行证常量定义 */

if( typeof( CometPassportDefine ) == "undefined" )
{
	try
	{
		eval('																		\r\n\
			const CometPassportDefine = {											\r\n\
				/* 配置项定义 */													\r\n\
				option_category			: "comet.passport.",						\r\n\
				// 保存密码HOST														\r\n\
				login_host				: "www.atcomet.com",						\r\n\
				login_realm				: "passport",								\r\n\
																					\r\n\
				/* 事件定义 */														\r\n\
				// 用户帐号发生改变													\r\n\
				event_saved				: "comet.passport.event.saved",				\r\n\
				// 网站登录帐号														\r\n\
				event_web_login			: "comet.passport.event.web_login",			\r\n\
				// 网站登出帐号														\r\n\
				event_web_logout		: "comet.passport.event.web_logout"			\r\n\
			};																		\r\n\
		');
	} catch( e ) { }
}

/* // 彗星通行证事件监听

var CometPassportObserver = new function()
{
	this.observe = function( subject, topic, data )
	{
		if ( topic == CometPassportDefine.event_saved )
		{
			// 帐号发生改变时的处理代码
		}
		
		if ( topic == CometPassportDefine.event_web_login )
		{
			// 网站登录帐号
			var user = JSON.parse( data );
			user.name;
			user.password;
		}
		
		if ( topic == CometPassportDefine.event_web_logout )
		{
			// 网站登出帐号
			var user = JSON.parse( data );
			user.name;
		}
	};

	this.register = function()
	{
		var _observer_service 	= Components.classes["@mozilla.org/observer-service;1"].getService( Components.interfaces.nsIObserverService );
		_observer_service.addObserver( this, CometPassportDefine.event_saved, false );
		_observer_service.addObserver( this, CometPassportDefine.event_web_login, false );
		_observer_service.addObserver( this, CometPassportDefine.event_web_logout, false );
	}; 

	this.unregister = function()
	{
		var _observer_service 	= Components.classes["@mozilla.org/observer-service;1"].getService( Components.interfaces.nsIObserverService );
		_observer_service.removeObserver( this, CometPassportDefine.event_saved );
		_observer_service.removeObserver( this, CometPassportDefine.event_web_login );
		_observer_service.removeObserver( this, CometPassportDefine.event_web_logout );
	}; 

}; */

var CometPassport = {
	/* 内核对象 */
	_pref_service	: Components.classes["@mozilla.org/preferences-service;1"].getService( Components.interfaces.nsIPrefService ),
	
	/* 功能函数 */
	// 取得用户名
	getUsername : function()
	{
		// 访问配置需要的对象
		var prefs 		= this._pref_service.getBranch( CometPassportDefine.option_category );
		var username	= "";
		
		if( null != prefs )
		{
			if( prefs.prefHasUserValue( "Username" ) )
				username	= prefs.getComplexValue( "Username", Components.interfaces.nsIPrefLocalizedString ).data;
		}

		return username;
	},

	// 取得用户密码
	getPassword : function()
	{
		var username	= this.getUsername();
		if( username == "" )
			return "";
		
		// 访问密码需要的对象
		var pref	= this.getLoginInfo( username );
		if( null == pref )
			return "";
			
		return pref.password;
	},
	
	// 设置Passport用户名和密码
	setUsername : function(Username, Password)
	{
		// 保存用户名和密码
		// 访问配置需要的对象
		var prefs 	= this._pref_service.getBranch( CometPassportDefine.option_category );
		var value	= Components.classes["@mozilla.org/pref-localizedstring;1"].createInstance(Components.interfaces.nsIPrefLocalizedString);
		
		value.data 	= Username;

		prefs.setComplexValue( "Username", Components.interfaces.nsIPrefLocalizedString, value );

		if( Username != "" )
		{
			// 访问密码需要的对象
			var password	= this.getPassword();
			if( password != "" )
				this.remove( Username );

			var _login_manager 	= Components.classes["@mozilla.org/login-manager;1"].getService( Components.interfaces.nsILoginManager );
			var login_obj 		= new Components.Constructor( "@mozilla.org/login-manager/loginInfo;1", Components.interfaces.nsILoginInfo, "init" );
			if( Password != "" )
				_login_manager.addLogin( new login_obj( CometPassportDefine.login_host, null, CometPassportDefine.login_realm, Username, Password, "", "" ) );
		}

		// 发送Event使用的对象
		var _observer_service 	= Components.classes["@mozilla.org/observer-service;1"].getService( Components.interfaces.nsIObserverService );

		// 通知监听者新用户帐号已保存
		if( null != _observer_service )
			_observer_service.notifyObservers( null, CometPassportDefine.event_saved, "" );
	},
	
	// 删除通行证相关的配置项
	clear : function()
	{
		var username	= this.getUsername();
		if( username != "" )
		{
			// 访问密码需要的对象
			var password	= this.getPassword();
			if( password != "" )
				this.remove( username );
		}

		// 访问配置需要的对象
		var prefs 			= this._pref_service.getBranch( CometPassportDefine.option_category );
		prefs.deleteBranch( "" );// delete all value of cometmarks	

		// 发送Event使用的对象
		var _observer_service 	= Components.classes["@mozilla.org/observer-service;1"].getService( Components.interfaces.nsIObserverService );

		// 通知监听者新用户帐号已保存
		if( null != _observer_service )
			_observer_service.notifyObservers( null, CometPassportDefine.event_saved, "" );
	},
	
	remove : function(username)
	{
		var _login_manager 	= Components.classes["@mozilla.org/login-manager;1"].getService( Components.interfaces.nsILoginManager );

		// 移除用户密码
		var pref	= this.getLoginInfo( username );
		if( null != pref )
			_login_manager.removeLogin( pref );
	},

	// 取得登录对象
	getLoginInfo : function(username)
	{
		// 访问密码需要的对象
		var _login_manager 	= Components.classes["@mozilla.org/login-manager;1"].getService( Components.interfaces.nsILoginManager );
		var prefs 			= _login_manager.findLogins( {}, CometPassportDefine.login_host, null, CometPassportDefine.login_realm );

		for( var i = 0; i < prefs.length; i++ ) 
		{
			if( prefs[ i ].username != username )
				continue;
			
			return prefs[ i ];
		}
		
		return null;
	},
};
