﻿/* define cometmarks notes const variables */
if( typeof( CometMarksNotesDefined ) == "undefined" )
{
	try
	{
		eval('																						\r\n\
			const CometMarksNotesDefined =															\r\n\
			{																						\r\n\
				/* send event */ 																	\r\n\
				// 	note panels exchanged in different browser										\r\n\
				event_note_status				:	"cometmarks.notes.event.status",				\r\n\
				// 	note content changed															\r\n\
				event_note_changed				:	"cometmarks.notes.event.note_changed",			\r\n\
				/* status: close the panel */ 														\r\n\
				status_close					:	"cometmarks.notes.status.close"					\r\n\
			};																						\r\n\
		');
	} 
	catch( e ) 
	{
		alert ( e ); 
	}
}

////////////////////////////////////////////////////////////////
/* notes observer class */
var CometmarksNotesObserver =
{
	_bookmarks_version : 0,
	observe: function( subject, topic, data )
	{
		// get kernel state
		var kernelState = CometMarksKernel.getState();
		switch( topic )
		{
			case CometMarksKernelDefine.event_sync :
				if ( kernelState.bookmarks_version > this._bookmarks_version && data == "OK")
				{
					this.syncNotes();
					this._bookmarks_version = kernelState.bookmarks_version;
				}
				break;
			case CometMarksKernelDefine.event_update :
			case CometMarksKernelDefine.event_overwrite :	
				// success or no-record
				if ( kernelState.work_state == CometMarksKernelDefine.work_state_success || kernelState.work_state == CometMarksKernelDefine.work_state_no_record )
				{
					this.updateNotes();
				}
				break;
					
			case CometMarksKernelDefine.event_logout :
				this.closeNotes();
				break;
				
			case CometMarksNotesDefined.event_note_changed :
				// notify bookmarks note changed
				var os = Components.classes["@mozilla.org/observer-service;1"].getService(Components.interfaces.nsIObserverService);
				os.notifyObservers( null, CometMarksBookMarksDefine.event_note_changed, null );
				break;
				
			default :
				this.closeNotes();
				break;
		}
	},
	
	syncNotes : function()
	{
	try{
		// get server notes
		var server_notes = CometMarksKernel.getBookmarksContent();
		if(server_notes.length < 1)
			return;
		var server_notes_data = this.parseNoteXml(server_notes);
		if(!server_notes_data)
			return;
		CometmarksNotesHandler._server_notes_data = server_notes_data;
		
		var commited_notes = CometMarksKernel.getBookmarksCommitted();
		CometmarksNotesHandler._commited_note_data = this.parseNoteXml(commited_notes);
		if(!CometmarksNotesHandler._commited_note_data)
			CometmarksNotesHandler._commited_note_data = [];
		
		if(CometmarksNotesHandler._local_notes_data.length == 0)
			this.getAndSaveLocalNotes();
		//alert('server notes:' + CometmarksNotesHandler._server_notes_data.length + ',commited_notes:' + CometmarksNotesHandler._commited_note_data.length + ',local_notes:' + CometmarksNotesHandler._local_notes_data.length);

		// update local note
		this.syncLocalNotes();
	}catch(e){write_log(e);}
	},
	
	updateNotes : function()
	{
	try{
		var server_notes = CometMarksKernel.getBookmarksContent();
		CometmarksNotesHandler._server_notes_data = this.parseNoteXml(server_notes);
		this.updateLocalNotes();
	}catch(e){write_log(e);}
	},
	
	parseNoteXml : function(bookmarks_content)
	{
	try{
		if ( bookmarks_content == "" )
			return false;
		
		var parser = new DOMParser();
		var xmlDoc = parser.parseFromString( bookmarks_content, "text/xml" );
			
		var oEvaluator = new XPathEvaluator();
		var sXPath = "/nodeset/node/children/node/guid";
		var oResult = oEvaluator.evaluate( sXPath, xmlDoc.documentElement, null, XPathResult.ORDERED_NODE_ITERATOR_TYPE, null );
		if ( oResult == null )// don't find cometmarks note node
			return false;

		var elem_note = null;
		var oElement_note;
		var is_notes_exist = false;
		while ( oElement_note = oResult.iterateNext() ) 
		{
			if ( oElement_note.textContent == "BOOKMARK_NOTES" )
			{
				elem_note = oElement_note.parentNode;
				is_notes_exist = true;
				break;
			}
		}
		
		if ( !is_notes_exist )
			return false;
			
		sXPath = "./children/node";
		oResult = oEvaluator.evaluate( sXPath, elem_note, null, XPathResult.ORDERED_NODE_ITERATOR_TYPE, null );
		if ( oResult == null ) // don't find note's content
			return false;
			
		var note_data_list = [];
		var oElement;
		while ( oElement = oResult.iterateNext() )// save all notes into files
		{	
			var note_info = oElement.childNodes;	
			var note_data = new Object();

			for ( var j=0; j<note_info.length; j++ )
			{
				if ( note_info[j].nodeType == Node.ELEMENT_NODE && note_info[j].tagName == "guid" )
					note_data.guid = note_info[j].textContent;

				if ( note_info[j].nodeType == Node.ELEMENT_NODE && note_info[j].tagName == "type" )
					note_data.type = note_info[j].textContent;

				if ( note_info[j].nodeType == Node.ELEMENT_NODE && note_info[j].tagName == "name" )
					note_data.title = note_info[j].textContent;

				if ( note_info[j].nodeType == Node.ELEMENT_NODE && note_info[j].tagName == "content" )
				{
					note_data.value = CometmarksNotesHandler.format(note_info[j].textContent);
				}
			}
			note_data_list.push(note_data);
		}
		return note_data_list;
	}catch(e){write_log(e);return false;}
	},
	
	getAndSaveLocalNotes : function()
	{
	try{
		// get local notes
		var note_str = CometMarksKernel.getLocalNotes();
		//note_str = CometmarksNotesHandler.format(note_str);
		
		// clear old data 
		while ( CometmarksNotesHandler._local_notes_data.length > 0 )
			CometmarksNotesHandler._local_notes_data.shift();	

		// anlyze note: convert str to dom struct
		var parser = new DOMParser();
		var doc = parser.parseFromString( note_str, "text/xml");
		 
		var noteset = doc.getElementsByTagName("noteset");
		var note_list = noteset[0].childNodes;
		for ( var i=0; i<note_list.length; i++ )
		{
			if ( note_list[i].nodeType == Node.ELEMENT_NODE )
			{
				var note_info = note_list[i].childNodes;
				var note_data = new Object();
				 
				for ( var j=0; j<note_info.length; j++ )
				{
					if ( note_info[j].nodeType == Node.ELEMENT_NODE && note_info[j].tagName == "guid" )
						note_data.guid = note_info[j].textContent;

					if ( note_info[j].nodeType == Node.ELEMENT_NODE && note_info[j].tagName == "type" )
						note_data.type = note_info[j].textContent;

					if ( note_info[j].nodeType == Node.ELEMENT_NODE && note_info[j].tagName == "name" )
						note_data.title = note_info[j].textContent;

					if ( note_info[j].nodeType == Node.ELEMENT_NODE && note_info[j].tagName == "content" )
					{
						note_data.value = note_info[j].textContent;
						note_data.value = CometmarksNotesHandler.format(note_data.value);
					}
				}
				CometmarksNotesHandler._local_notes_data.push(note_data);
			}
		}
	}catch(e){write_log(e);}
	},
	
	updateLocalNotes : function()
	{
	try{
		if(CometmarksNotesHandler._current_note_id < CometmarksNotesHandler._local_notes_data.length)
		{
			var current_note_data = CometmarksNotesHandler._local_notes_data[CometmarksNotesHandler._current_note_id].guid;
		}
		CometmarksNotesHandler._current_note_id = 0;
		
		while ( CometmarksNotesHandler._local_notes_data.length > 0 )
			CometmarksNotesHandler._local_notes_data.shift();	
		
		for(var i=0; i<CometmarksNotesHandler._server_notes_data.length; ++i)
		{
			var new_note_data = new Object();
			new_note_data.guid = CometmarksNotesHandler._server_notes_data[i].guid;
			new_note_data.type = CometmarksNotesHandler._server_notes_data[i].type;
			new_note_data.title = CometmarksNotesHandler._server_notes_data[i].title;
			new_note_data.value = CometmarksNotesHandler._server_notes_data[i].value;
			CometmarksNotesHandler._local_notes_data.push(new_note_data);
			if(current_note_data != null && new_note_data.guid == current_note_data.guid)
				CometmarksNotesHandler._current_note_id = i;
		}
		
		if(CometmarksNotesHandler._current_note_id < CometmarksNotesHandler._current_page_begin || CometmarksNotesHandler._current_note_id - CometmarksNotesHandler._current_page_begin >= CometmarksNotesHandler._label_tab_list.length)
		{
			if(CometmarksNotesHandler._current_note_id > 0)
				CometmarksNotesHandler._current_page_begin = CometmarksNotesHandler._current_note_id - 1;
			else
				CometmarksNotesHandler._current_page_begin = 0;
		}
		if(current_note_data != null && CometmarksNotesHandler._local_notes_data[CometmarksNotesHandler._current_note_id].value == current_note_data.value)
		{
			CometmarksNotesHandler.noteShowLabPannel();
		}
		else
		{
			CometmarksNotesHandler.noteSelectTab(null, CometmarksNotesHandler._current_note_id);
		}
	}catch(e){write_log(e);}
	},
	
	syncLocalNotes : function()
	{
		var panel = document.getElementById( "cometmarks_note_panel" );
		var panel_opened = false;
		var data_changed = false;
		if ( panel != null && panel.state == "open" )//opened
		{
			//当前编辑的便签，使用控件里的数据作为本地数据
			if(CometmarksNotesHandler._current_note_id < CometmarksNotesHandler._local_notes_data.length)
			{
				var current_note_content = CometmarksNotesHandler.format(document.getElementById("panel_note_text").value);
				if(current_note_content != CometmarksNotesHandler._local_notes_data[CometmarksNotesHandler._current_note_id].value)
				{
					CometmarksNotesHandler._local_notes_data[CometmarksNotesHandler._current_note_id].value = current_note_content;
					data_changed = true;
				}
			}
			panel_opened = true;
		}
		
		//遍历同步结果
		var last_local_position = null;
		for(var i=0; i<CometmarksNotesHandler._server_notes_data.length; i++)
		{
			var server_note = CometmarksNotesHandler._server_notes_data[i];	//同步结果
			for( var j=0; j<CometmarksNotesHandler._commited_note_data.length; j++)
			{
				if(CometmarksNotesHandler._commited_note_data[j].guid == server_note.guid)
				{
					var commit_note = CometmarksNotesHandler._commited_note_data[j];	//上次提交数据
					break;
				}
			}
			
			for(var k=0; k<CometmarksNotesHandler._local_notes_data.length;k++)
			{
				if(CometmarksNotesHandler._local_notes_data[k].guid == server_note.guid)
				{
					var local_note = CometmarksNotesHandler._local_notes_data[k];	//本地数据
					last_local_position = k;
					break;
				}
			}
			
			//如果上次提交的数据没有该便签，添加到本地数据
			if(j==CometmarksNotesHandler._commited_note_data.length && k==CometmarksNotesHandler._local_notes_data.length)
			{
				var position = 0;
				if(last_local_position != null)
					position = last_local_position + 1;
					
				CometmarksNotesHandler._local_notes_data.splice(position, 0, CometmarksNotesHandler.cloneNote(server_note));	
				if(position <= CometmarksNotesHandler._current_note_id)
				{
					if( CometmarksNotesHandler._current_page_begin <= CometmarksNotesHandler._current_note_id && CometmarksNotesHandler._current_note_id - CometmarksNotesHandler._current_page_begin < CometmarksNotesHandler._label_tab_list.length )
						CometmarksNotesHandler._current_page_begin++;
					CometmarksNotesHandler._current_note_id++;
				}
				data_changed = true;
			}
			else if(k < CometmarksNotesHandler._local_notes_data.length)
			{
				//同步结果与上次提交数据不同
				if(j<CometmarksNotesHandler._commited_note_data.length && (commit_note.type != server_note.type || commit_note.title != server_note.title || commit_note.value != server_note.value))
				{
					//本地数据与上次提交的数据相同，则使用同步结果覆盖本地数据并刷新控件
					if(j<CometmarksNotesHandler._commited_note_data.length && local_note.type == commit_note.type && local_note.title == commit_note.title && local_note.value == commit_note.value)
					{
						local_note.type = server_note.type;
						local_note.title = server_note.title;
						local_note.value = server_note.value;
						data_changed = true;
					}
					else if(local_note.type != server_note.type || local_note.title != server_note.title || local_note.value != server_note.value)
					{
						//同步结果与提交前数据不相等，本地数据与提交前数据也不相等，且同步结果与本地数据也不相等
						var bubble = Components.classes["@mozilla.org/intl/stringbundle;1"].getService(Components.interfaces.nsIStringBundleService).createBundle("chrome://cometmarks/locale/cometmarks.properties");
						var confirm_message = bubble.GetStringFromName("cometmarks.notes.changeconfirm");

						if(panel_opened && confirm(confirm_message))
						{
							// 当前编辑的内容使用新的GUID做为新便签，服务器的便签在新控件显示
							var current_note_content = CometmarksNotesHandler.format(document.getElementById("panel_note_text").value);
							var new_note_data = new Object();
							new_note_data.guid = CometMarksUtility.createGuid();
							new_note_data.type = "note";
							new_note_data.title = CometmarksNotesHandler._local_notes_data[CometmarksNotesHandler._current_note_id].title;
							new_note_data.value = current_note_content;
							CometmarksNotesHandler._local_notes_data[CometmarksNotesHandler._current_note_id].title = server_note.title;
							CometmarksNotesHandler._local_notes_data[CometmarksNotesHandler._current_note_id].value = server_note.value;
							CometmarksNotesHandler._local_notes_data.push(new_note_data);
							if(CometmarksNotesHandler._local_notes_data.length - CometmarksNotesHandler._current_page_begin > 2)
								CometmarksNotesHandler._current_page_begin = CometmarksNotesHandler._local_notes_data.length - 2;
							CometmarksNotesHandler._current_note_id = CometmarksNotesHandler._local_notes_data.length - 1;
							if(panel_opened)
								CometmarksNotesHandler.noteSelectTab(null, CometmarksNotesHandler._current_note_id);
						}
						else
						{
							//使用同步结果覆盖本地数据并刷新控件
							CometmarksNotesHandler._local_notes_data[CometmarksNotesHandler._current_note_id].title = server_note.title;
							CometmarksNotesHandler._local_notes_data[CometmarksNotesHandler._current_note_id].value = server_note.value;
						}
						data_changed = true;
					}
				}
			}
		}
		
		//遍历本地数据
		var local_notes_length = CometmarksNotesHandler._local_notes_data.length;
		var i=0;
		var local_has_newnote = false;
		while(i<CometmarksNotesHandler._local_notes_data.length)
		{
			for(var j=0; j<CometmarksNotesHandler._server_notes_data.length; j++)
			{
				if(CometmarksNotesHandler._server_notes_data[j].guid == CometmarksNotesHandler._local_notes_data[i].guid)
					break;
			}
			//同步结果里删除了本地数据里的这条便签
			if(j==CometmarksNotesHandler._server_notes_data.length)
			{
				for(var k=0; k<CometmarksNotesHandler._commited_note_data.length; k++)
				{
					if(CometmarksNotesHandler._commited_note_data[k].guid == CometmarksNotesHandler._local_notes_data[i].guid)
						break;
				}
				//上次提交的数据有该便签
				if(k<CometmarksNotesHandler._commited_note_data.length)
				{
					//删除对应的显示控件及本地数据
					if(CometmarksNotesHandler._local_notes_data.length > 0)
					{
						if(CometmarksNotesHandler._current_note_id>i)
							CometmarksNotesHandler._current_note_id--;
						if(CometmarksNotesHandler._current_note_id == i && CometmarksNotesHandler._current_note_id + 1 >= CometmarksNotesHandler._local_notes_data.length)
							CometmarksNotesHandler._current_note_id--;
						if(CometmarksNotesHandler._current_page_begin > CometmarksNotesHandler._current_note_id)
							CometmarksNotesHandler._current_page_begin--;
						CometmarksNotesHandler._local_notes_data.splice(i, 1);
						data_changed = true;
						continue;
					}
				}
				local_has_newnote = true;
			}
			i++;
		}
		
		//调整顺序，保持和服务器数据顺序一至
		if(!local_has_newnote && CometmarksNotesHandler._server_notes_data.length == CometmarksNotesHandler._local_notes_data.length)
		{
			var local_notes_data = [];
			for(var i=0; i<CometmarksNotesHandler._server_notes_data.length; i++)
			{
				for(var j=0; j<CometmarksNotesHandler._local_notes_data.length; j++)
				{
					if(CometmarksNotesHandler._server_notes_data[i].guid == CometmarksNotesHandler._local_notes_data[j].guid)
					{
						if(j != i)
							data_changed = true;
							
						local_notes_data.push(CometmarksNotesHandler._local_notes_data[j]);
						
						if(CometmarksNotesHandler._current_note_id == j && j != i)
						{
							CometmarksNotesHandler._current_note_id = local_notes_data.length - 1;
							CometmarksNotesHandler._current_page_begin = CometmarksNotesHandler._current_note_id;
						}
						break;
					}
				}
			}
			
			CometmarksNotesHandler._local_notes_data = local_notes_data;
		}
		
		if(panel_opened && CometmarksNotesHandler._local_notes_data.length != local_notes_length)
		{
			if(CometmarksNotesHandler._local_notes_data.length == 0)
			{
				var bubble = Components.classes["@mozilla.org/intl/stringbundle;1"].getService(Components.interfaces.nsIStringBundleService).createBundle("chrome://cometmarks/locale/cometmarks.properties");
				var newnote_title = bubble.GetStringFromName("cometmarks.notes.newnote.title");
				var new_note_data = new Object();
				new_note_data.guid = CometMarksUtility.createGuid();
				new_note_data.type = "note";
				new_note_data.title = newnote_title;
				new_note_data.value = "";
				new_note_data.value = CometmarksNotesHandler.addTime(new_note_data.value);
				CometmarksNotesHandler._local_notes_data.push(new_note_data);
				CometmarksNotesHandler._current_note_id = 0;
				CometmarksNotesHandler._current_page_begin = 0;
			}
			data_changed = true;
		}
		if(data_changed)
		{
			var current_note_content = CometmarksNotesHandler.format(document.getElementById("panel_note_text").value);
			if(current_note_content != CometmarksNotesHandler._local_notes_data[CometmarksNotesHandler._current_note_id].value)
				CometmarksNotesHandler.noteSelectTab(null, CometmarksNotesHandler._current_note_id);
			else
				CometmarksNotesHandler.noteShowLabPannel();
			document.getElementById("note_save_image").setAttribute("status", "disabled" );		
			document.getElementById("note_save_image").setAttribute("usable", "0" );
			CometmarksNotesHandler.setLocalNotes();
		}
		//alert('sync server notes:' + CometmarksNotesHandler._server_notes_data.length + ',commited_notes:' + CometmarksNotesHandler._commited_note_data.length + ',local_notes:' + CometmarksNotesHandler._local_notes_data.length);
	},
	
	closeNotes : function()
	{
		CometmarksNotesHandler.notePanelDoclose( true );
	}
};

/////////////////////////////////////////////////////////
/* Notes Handl*/
var CometmarksNotesHandler = 
{
	/* all members */
	_is_real_popup				: false,
	_is_resize_select			: false,
	_is_panel_select			: false,
	
	_original_mouse_x			: 0,
	_original_mouse_y			: 0,
		
	_target_original_y			: 0,
	_target_original_x			: 0,
	_target_original_width		: 0,
	_target_original_height		: 0,
	
	_current_label_tab			: "label_note_1",
	_current_textbox_tab		: "",
	_current_note_id			: 0,
	_current_page_begin			: 0,
	
	_last_label_tab				: "",
	_last_label_id				: -1,
	_last_note_title			: "",
	_last_note_value			: "",
	
	_local_notes_data 			: [],
	_commited_note_data			: [],
	_server_notes_data			: [],
	_label_tab_list				: ["label_note_1", "label_note_2", "label_note_3"],
	
	/* all methods */
	init : function()
	{
		// register observer
		var observerService = Components.classes["@mozilla.org/observer-service;1"].getService(Components.interfaces.nsIObserverService);
		observerService.addObserver( CometmarksNotesObserver, CometMarksKernelDefine.event_update, false );
		observerService.addObserver( CometmarksNotesObserver, CometMarksKernelDefine.event_sync, false );
		observerService.addObserver( CometmarksNotesObserver, CometMarksKernelDefine.event_overwrite, false );
		observerService.addObserver( CometmarksNotesObserver, CometMarksKernelDefine.event_logout, false );
		observerService.addObserver( CometmarksNotesObserver, CometMarksNotesDefined.event_note_changed, false );
	},
	
	release : function()
	{
		// remove observer
		var observerService = Components.classes["@mozilla.org/observer-service;1"].getService(Components.interfaces.nsIObserverService);
		observerService.removeObserver( CometmarksNotesObserver, CometMarksKernelDefine.event_update );
		observerService.removeObserver( CometmarksNotesObserver, CometMarksKernelDefine.event_sync );
		observerService.removeObserver( CometmarksNotesObserver, CometMarksKernelDefine.event_overwrite );
		observerService.removeObserver( CometmarksNotesObserver, CometMarksKernelDefine.event_logout );
		observerService.removeObserver( CometmarksNotesObserver, CometMarksNotesDefined.event_note_changed );
	},
	
	showNotePanel : function()
	{
	try{	
		// for shot key
		if ( document.getElementById("cometmarks_show_note_menuitem").getAttribute("disabled") == "true" )
			return;

		var panel = document.getElementById( "cometmarks_note_panel" );
		if ( panel == null )
			return;
			
		if ( panel.state == "open" )// has opened
		{
			CometmarksNotesHandler.notePanelDoclose(true);
			return;
		}
		
		// close note panel
		var os = Components.classes["@mozilla.org/observer-service;1"].getService(Components.interfaces.nsIObserverService);
		os.notifyObservers( null, CometMarksNotesDefined.event_note_status, CometMarksNotesDefined.status_close );
		
		// get last position
		var ps = Components.classes["@mozilla.org/preferences-service;1"].getService(Components.interfaces.nsIPrefService);
		var prefs = ps.getBranch("cometmarks.");
		var notes_dialog_x = prefs.getIntPref("notes_dialog.x");
		var notes_dialog_y = prefs.getIntPref("notes_dialog.y");
		var notes_dialog_width = prefs.getIntPref("notes_dialog.width");
		var notes_dialog_height = prefs.getIntPref("notes_dialog.height");
				
		if ( notes_dialog_x == 0 && notes_dialog_y == 0 )// original value
		{
			notes_dialog_x = ( window.screen.width - notes_dialog_width ) / 2;
			notes_dialog_y = ( window.screen.height - notes_dialog_height ) / 2;
		}
		
		// open panel
		this._is_real_popup = true;
		
		// init local data
		CometmarksNotesObserver.syncNotes();	
		//this._current_note_id = 0;
		panel.openPopupAtScreen( notes_dialog_x, notes_dialog_y, false );
		panel.sizeTo( notes_dialog_width, notes_dialog_height );
		
		// add event listener
		panel.addEventListener( "mousedown", CometmarksNotesHandler.panelMouseDown, false );
		panel.addEventListener( "mouseup", CometmarksNotesHandler.panelMouseUp, false ); 
		panel.addEventListener( "mousemove", CometmarksNotesHandler.panelMouseMove, false );
		panel.addEventListener( "mouseout", CometmarksNotesHandler.panelMouseOut, false );
	}catch(e){write_log(e);}
	},

	notePanelPopup : function()
	{		
		if ( !this._is_real_popup )
			return;
		this._is_real_popup = false;

		if(CometmarksNotesHandler._local_notes_data.length == 0)
		{
			var bubble = Components.classes["@mozilla.org/intl/stringbundle;1"].getService(Components.interfaces.nsIStringBundleService).createBundle("chrome://cometmarks/locale/cometmarks.properties");
			var newnote_title = bubble.GetStringFromName("cometmarks.notes.newnote.title");
			var new_note_data = new Object();
			new_note_data.guid = CometMarksUtility.createGuid();
			new_note_data.type = "note";
			new_note_data.title = newnote_title;
			new_note_data.value = "";
			new_note_data.value = CometmarksNotesHandler.addTime(new_note_data.value);
			CometmarksNotesHandler._local_notes_data.push(new_note_data);
			CometmarksNotesHandler.setLocalNotes();
		}
		
		if(CometmarksNotesHandler._current_page_begin >= CometmarksNotesHandler._local_notes_data.length)
			CometmarksNotesHandler._current_page_begin = CometmarksNotesHandler._local_notes_data.length - 1;
		if(CometmarksNotesHandler._current_note_id >= CometmarksNotesHandler._local_notes_data.length)
			CometmarksNotesHandler._current_note_id = CometmarksNotesHandler._local_notes_data.length - 1;
		
		// set note temp data
		if ( CometMarksGlobal.getGlobalData().current_note_guid != null )
		{
			for ( var i=0; i<CometmarksNotesHandler._local_notes_data.length; i++ )
			{
				if ( CometmarksNotesHandler._local_notes_data[i].guid == CometMarksGlobal.getGlobalData().current_note_guid )
				{
					CometmarksNotesHandler._current_note_id = i;
					if(i > 0)
						CometmarksNotesHandler._current_page_begin = i - 1;
					else
						CometmarksNotesHandler._current_page_begin = 0;
					break;
				}
			}
		}
		
		// open label	
		this.noteSelectTab(null, CometmarksNotesHandler._current_note_id);

		// set check state	
		//status bar	
		var note_statebar = document.getElementById("cometmarks_show_note_statebar");
		note_statebar.setAttribute( "checked", "true" );
		
		//menu
		var note_menu = document.getElementById("cometmarks_show_note_menuitem");
		note_menu.setAttribute( "checked", "true" );
	},

	notePanelClose : function( event )
	{
		if ( event.button != 0 )// not left button
			return;
		
		CometmarksNotesHandler.notePanelDoclose( true );
	},
	
	setLocalNotes : function( )
	{
	try{
		var note_str = CometMarksKernel.getLocalNotes();
		
		var local_notes_data = [];
		if(note_str.length > 1)
		{
			var parser = new DOMParser();
			var doc = parser.parseFromString( note_str, "text/xml");
			 
			var noteset = doc.getElementsByTagName("noteset");
			var note_list = noteset[0].childNodes;
			for ( var i=0; i<note_list.length && i<3; i++ )
			{
				if ( note_list[i].nodeType == Node.ELEMENT_NODE )
				{
					var note_info = note_list[i].childNodes;
					var note_data = new Object();
					 
					for ( var j=0; j<note_info.length; j++ )
					{
						if ( note_info[j].nodeType == Node.ELEMENT_NODE && note_info[j].tagName == "guid" )
							note_data.guid = note_info[j].textContent;

						if ( note_info[j].nodeType == Node.ELEMENT_NODE && note_info[j].tagName == "type" )
							note_data.type = note_info[j].textContent;

						if ( note_info[j].nodeType == Node.ELEMENT_NODE && note_info[j].tagName == "name" )
							note_data.title = note_info[j].textContent;

						if ( note_info[j].nodeType == Node.ELEMENT_NODE && note_info[j].tagName == "content" )
							note_data.value = note_info[j].textContent;
				  }
				  // save notes
				  local_notes_data.push( note_data );
				}
			}
		}

		var notes_changed = false;
		if( local_notes_data.length != CometmarksNotesHandler._local_notes_data.length )
			notes_changed = true;
		
		for( var i=0; i<CometmarksNotesHandler._local_notes_data.length; i++ )
		{
			var local_note = CometmarksNotesHandler._local_notes_data[i];
			for( var j=0; j<local_notes_data.length; j++ )
			{
				var commited_note = local_notes_data[j];
				if( local_note.guid == commited_note.guid )
				{
					if( local_note.type != commited_note.type || local_note.title != commited_note.title || local_note.value != commited_note.value )
					{
						notes_changed = true;
					}
					break;
				}
			}
			
			if( j==local_notes_data.length || notes_changed )
			{
				notes_changed = true;
				break;
			}
		}
		
		if(!notes_changed)
			return;		
		
		// create xml
		var xmldoc = document.implementation.createDocument( "","",null );
		var head = xmldoc.createProcessingInstruction( "xml","version=\"1.0\"  encoding=\"UTF-8\" standalone=\"yes\"" );
		xmldoc.appendChild(head);
		var noteset = xmldoc.createElement("noteset");
		
		//CometmarksNotesHandler._commited_note_data.reverse();
		for ( var i=0; i<CometmarksNotesHandler._local_notes_data.length; i++ )
		{
			var note = CometMarksBookMarks.createElementParent( xmldoc, noteset, "note" );
			CometMarksBookMarks.createElement( xmldoc, note, "guid", CometmarksNotesHandler._local_notes_data[i].guid );
			CometMarksBookMarks.createElement( xmldoc, note, "type", CometmarksNotesHandler._local_notes_data[i].type );
			CometMarksBookMarks.createElement( xmldoc, note, "name", CometmarksNotesHandler._local_notes_data[i].title );
			CometMarksBookMarks.createElement( xmldoc, note, "content", CometmarksNotesHandler._local_notes_data[i].value );
		}
	  
		xmldoc.appendChild(noteset);
		//CometmarksNotesHandler._commited_note_data.reverse();

		var serializer = new XMLSerializer();
		var str = serializer.serializeToString(xmldoc);
		
		// set local notes
		//alert('setLocalNotes');
		CometMarksKernel.setLocalNotes( str );
		// notify to commit new note data
		var os = Components.classes["@mozilla.org/observer-service;1"].getService(Components.interfaces.nsIObserverService);
		os.notifyObservers( null, CometMarksNotesDefined.event_note_changed, null );
	}catch(e){write_log(e);}
	},

	notePanelDoclose : function( is_real_close )
	{	
		// save size and position
		var panel = document.getElementById("cometmarks_note_panel");
		if ( panel == null || panel.state != "open" )
			return;
			
		var ps = Components.classes["@mozilla.org/preferences-service;1"].getService(Components.interfaces.nsIPrefService);
		var prefs = ps.getBranch("cometmarks.");
		prefs.setIntPref( "notes_dialog.x", panel.boxObject.screenX );
		prefs.setIntPref( "notes_dialog.y", panel.boxObject.screenY );
		prefs.setIntPref( "notes_dialog.width", panel.boxObject.width );
		prefs.setIntPref( "notes_dialog.height", panel.boxObject.height );
		
		//用户关闭便签对话框时，保存数据
		var content = CometmarksNotesHandler.format(document.getElementById("panel_note_text").value);
		if(content != CometmarksNotesHandler._local_notes_data[CometmarksNotesHandler._current_note_id].value)
		{
			CometmarksNotesHandler._local_notes_data[CometmarksNotesHandler._current_note_id].value = content;
			this.setLocalNotes( );
		}
		// reset note
		document.getElementById("panel_note_text").value = content + "\r\n\r\n";
		
		// only hide panel
		if ( !is_real_close )
		{		
			/*
			// save temp note data
			for ( var i=0; i<CometmarksNotesHandler._commited_note_data.length; i++ )
			{
				if ( CometmarksNotesHandler._local_notes_data[CometmarksNotesHandler._current_note_id].guid == CometmarksNotesHandler._commited_note_data[i].guid )
				{
					CometmarksNotesHandler._commited_note_data[i].type = CometmarksNotesHandler._local_notes_data[CometmarksNotesHandler._current_note_id].type;
					CometmarksNotesHandler._commited_note_data[i].title = CometmarksNotesHandler._local_notes_data[CometmarksNotesHandler._current_note_id].title;
					CometmarksNotesHandler._commited_note_data[i].value = CometmarksNotesHandler._local_notes_data[CometmarksNotesHandler._current_note_id].value;
					break;
				}
			}*/
			
			// hide panel
			panel.hidePopup();
			return;
		}
		
		// save all notes to xml file
		//var note_data = new Object();
		//note_data.guid = CometmarksNotesHandler._local_notes_data[CometmarksNotesHandler._current_note_id].guid;
		//note_data.type = CometmarksNotesHandler._local_notes_data[CometmarksNotesHandler._current_note_id].type;
		//note_data.title = CometmarksNotesHandler._local_notes_data[CometmarksNotesHandler._current_note_id].title;
		//note_data.value = CometmarksNotesHandler._local_notes_data[CometmarksNotesHandler._current_note_id].value;
		
		
		// save and notify
			
		// remove check state
		var note_statebar = document.getElementById("cometmarks_show_note_statebar");
		note_statebar.removeAttribute( "checked" );
		
		var note_menu = document.getElementById("cometmarks_show_note_menuitem");
		note_menu.removeAttribute( "checked" );
		
		// remove event listener
		panel.removeEventListener( "mousedown", CometmarksNotesHandler.panelMouseDown, false );
		panel.removeEventListener( "mouseup", CometmarksNotesHandler.panelMouseUp, false ); 
		panel.removeEventListener( "mousemove", CometmarksNotesHandler.panelMouseMove, false );
		panel.removeEventListener( "mouseout", CometmarksNotesHandler.panelMouseOut, false );
		
		// close panel
		panel.hidePopup();
	},

	// about panel move
	panelMouseDown : function( event )
	{
		if ( event.button != 0 )// not left button
			return;
			
		if ( event.target.id == "note_close_image" )// close note
		{
			// change close picture
			document.getElementById("note_close_image").setAttribute( "status", "mousein" );
			return;
		}
		
		if ( event.target.id == "note_cut_image" && event.target.getAttribute("usable")== "1" )// cut note
		{
			// change cut picture
			document.getElementById("note_cut_image").setAttribute( "status", "able" );
			return;
		}
		
		if ( event.target.id == "note_copy_image" && event.target.getAttribute("usable")== "1" )// copy note
		{
			// change copy picture
			document.getElementById("note_copy_image").setAttribute( "status", "mousedown" );
			return;
		}
		
		if ( event.target.id == "note_paste_image" && event.target.getAttribute("usable")== "1" )// paste note
		{
			// change paste picture
			document.getElementById("note_paste_image").setAttribute( "status", "able" );
			return;
		}
		
		if ( event.target.id == "note_save_image" && event.target.getAttribute("usable")== "1" )// save note
		{
			// change save picture
			document.getElementById("note_save_image").setAttribute( "status", "able" );
			return;
		}
		
		var panel = document.getElementById("cometmarks_note_panel");
		if ( event.target.id == "note_bottom_right_image" )// change note size
		{
			this._is_resize_select = true;
			this._original_mouse_x = event.screenX;
			this._original_mouse_y = event.screenY;
			this._target_original_width = panel.boxObject.width;
			this._target_original_height = panel.boxObject.height;
			return;
		}
		
		if ( event.target.getAttribute( "movable" ) != "1" )
			return;
		
		this._is_panel_select = true;
			
		// save current position	
		this._original_mouse_x = event.screenX;
		this._original_mouse_y = event.screenY;

		this._target_original_x = panel.boxObject.screenX + window.screen.availLeft;
		this._target_original_y = panel.boxObject.screenY + window.screen.availTop;
	},

	panelMouseMove : function( event )
	{
		var bubble = Components.classes["@mozilla.org/intl/stringbundle;1"].getService(Components.interfaces.nsIStringBundleService).createBundle("chrome://cometmarks/locale/cometmarks.properties");
		if ( event.target.id == "note_close_image" )
		{
			// change close picture
			document.getElementById("note_close_image").setAttribute( "status", "mouseover" );
			document.getElementById("note_close_image").tooltipText = bubble.GetStringFromName("cometmarks.notes.close");
			return;
		}
		
		if ( event.target.id == "note_cut_image" )// cut note
		{
			document.getElementById("note_cut_image").tooltipText = bubble.GetStringFromName("cometmarks.notes.cut");
			
			// change cut picture
			if ( event.target.getAttribute("usable")== "1" )
				document.getElementById("note_cut_image").setAttribute( "status", "mouseover" );
			
			return;
		}
		
		if ( event.target.id == "note_copy_image"  )// copy note
		{
			document.getElementById("note_copy_image").tooltipText = bubble.GetStringFromName("cometmarks.notes.copy");
			
			// change copy picture
			if ( event.target.getAttribute("usable")== "1" )
				document.getElementById("note_copy_image").setAttribute( "status", "mouseover" );
			
			return;
		}
		
		if ( event.target.id == "note_paste_image" )// paste note
		{
			document.getElementById("note_paste_image").tooltipText = bubble.GetStringFromName("cometmarks.notes.paste");
			
			// change paste picture
			if ( event.target.getAttribute("usable")== "1" )
				document.getElementById("note_paste_image").setAttribute( "status", "mouseover" );
			
			return;
		}
		
		if ( event.target.id == "note_save_image" )// save note
		{
			document.getElementById("note_save_image").tooltipText = bubble.GetStringFromName("cometmarks.notes.save");
			
			// change save picture
			if ( event.target.getAttribute("usable")== "1" )
				document.getElementById("note_save_image").setAttribute( "status", "mouseover" );
			
			return;
		}
		
		if ( event.target.id == "note_bottom_right_image" )// change resize curor
		{
			event.target.setAttribute( "style", "cursor: nwse-resize;" );
		}
		
		if ( this._is_resize_select )
		{
			var deltaX = event.screenX - this._original_mouse_x;
			var deltaY = event.screenY - this._original_mouse_y;
			var panel = document.getElementById("cometmarks_note_panel");
			panel.sizeTo( this._target_original_width + deltaX,  this._target_original_height + deltaY );
			return;
		}
		
		if ( !this._is_panel_select )
			return;

		var del_x = event.screenX - this._original_mouse_x;
		var del_y = event.screenY - this._original_mouse_y;
		
		//var dx = event.screenX - event.clientX;
		//var dy = event.screenY - event.clientY;
		
		var panel = document.getElementById("cometmarks_note_panel");
		if ( panel == null )
			return;
			
		panel.moveTo( this._target_original_x + del_x, this._target_original_y + del_y );
	},

	panelMouseUp : function( event )
	{
		if ( event.button != 0 )// not left button
			return;
			
		if ( event.target.id == "note_close_image" )
		{
			// change close picture
			document.getElementById("note_close_image").setAttribute( "status", "mouseout" );
			return;
		}
		
		if ( event.target.id == "note_cut_image" && event.target.getAttribute("usable")== "1" )// cut note
		{
			// change cut picture
			document.getElementById("note_cut_image").setAttribute( "status", "able" );
			return;
		}
		
		if ( event.target.id == "note_copy_image" && event.target.getAttribute("usable")== "1" )// copy note
		{
			// change copy picture
			document.getElementById("note_copy_image").setAttribute( "status", "able" );
			return;
		}
		
		if ( event.target.id == "note_paste_image" && event.target.getAttribute("usable")== "1" )// paste note
		{
			// change paste picture
			document.getElementById("note_paste_image").setAttribute( "status", "able" );
			return;
		}
		
		if ( event.target.id == "note_save_image" && event.target.getAttribute("usable")== "1" )// save note
		{
			// change save picture
			document.getElementById("note_save_image").setAttribute( "status", "able" );
			return;
		}
		
		if ( this._is_resize_select )
		{
			this._is_resize_select = false;
			return;
		}
		
		if ( !this._is_panel_select )
			return;

		this._is_panel_select = false;

		var del_x = event.screenX - this._original_mouse_x;
		var del_y = event.screenY - this._original_mouse_y;
		
		if ( del_x == 0 && del_y == 0 ) // not move
			return;
		
		// only call panel.hidePopup();
		CometmarksNotesHandler.notePanelDoclose( false ); 
		
		var panel = document.getElementById("cometmarks_note_panel");
		if ( panel == null )
			return;
			
		var screenx = this._target_original_x + del_x - window.screen.availLeft;
		if ( screenx + panel.boxObject.width > window.screen.availWidth -window.screen.availLeft - 3 )
		{
			screenx = window.screen.availWidth - panel.boxObject.width - window.screen.availLeft - 3;
		}

		var screeny = this._target_original_y + del_y - window.screen.availTop;
		if ( screeny + panel.boxObject.height > window.screen.availHeight -window.screen.availTop - 3 )
		{
			screeny = window.screen.availHeight - panel.boxObject.height - window.screen.availTop - 3;
		}
			
		this._is_real_popup = true;
		
		panel.openPopupAtScreen( screenx, screeny, false );
		var ps = Components.classes["@mozilla.org/preferences-service;1"].getService(Components.interfaces.nsIPrefService);
		var prefs = ps.getBranch("cometmarks.");
		panel.sizeTo( prefs.getIntPref("notes_dialog.width"), prefs.getIntPref("notes_dialog.height") );
	},

	panelMouseOut : function( event )
	{
		if ( event.target.id == "note_close_image" )
		{
			// change close picture
			document.getElementById("note_close_image").setAttribute( "status", "mouseout" );
		}
		
		if ( event.target.id == "note_cut_image" && event.target.getAttribute("usable")== "1" )// cut note
		{
			// change cut picture
			document.getElementById("note_cut_image").setAttribute( "status", "able" );
			return;
		}
		
		if ( event.target.id == "note_copy_image" && event.target.getAttribute("usable")== "1" )// copy note
		{
			// change copy picture
			document.getElementById("note_copy_image").setAttribute( "status", "able" );
			return;
		}
		
		if ( event.target.id == "note_paste_image" && event.target.getAttribute("usable")== "1" )// paste note
		{
			// change paste picture
			document.getElementById("note_paste_image").setAttribute( "status", "able" );
			return;
		}
		
		if ( event.target.id == "note_save_image" && event.target.getAttribute("usable")== "1" )// save note
		{
			// change save picture
			document.getElementById("note_save_image").setAttribute( "status", "able" );
			return;
		}
	},

	noteSelectTab : function( event, note_id )
	{			
		if ( event == null )
		{
			if(note_id >= CometmarksNotesHandler._current_page_begin && note_id - CometmarksNotesHandler._current_page_begin < 3)
			{
				var label_id = note_id - CometmarksNotesHandler._current_page_begin;
				this._current_label_tab = this._label_tab_list[label_id];
			}
			else if(note_id < CometmarksNotesHandler._local_notes_data.length)
			{
				var label_id = 0;
				CometmarksNotesHandler._current_page_begin = note_id;
				this._current_label_tab = this._label_tab_list[0];
			}
			else
				return;
		}
		else
		{
			if ( event.button != 0 )// not left button
				return;				
				
			if ( this._current_label_tab ==  event.target.id )
				return;
				
			this._current_label_tab =  event.target.id;
			
			for(var label_id=0; label_id<this._label_tab_list.length; ++label_id)
			{
				if(this._current_label_tab == this._label_tab_list[label_id])
					break;
			}
		}
		
		//用户切换选项卡时保存数据
		if(CometmarksNotesHandler._current_page_begin + label_id != CometmarksNotesHandler._current_note_id)
		{
			var label_value = document.getElementById("panel_note_text").value;	
			label_value = CometmarksNotesHandler.format(label_value);
			if(label_value != CometmarksNotesHandler._local_notes_data[CometmarksNotesHandler._current_note_id].value)
			{
				CometmarksNotesHandler._local_notes_data[CometmarksNotesHandler._current_note_id].value = label_value;
				CometmarksNotesHandler.setLocalNotes();
			}
		}

		CometmarksNotesHandler._current_note_id = CometmarksNotesHandler._current_page_begin + label_id;

		CometMarksGlobal.setData( CometMarksGlobalDefine.current_note_guid, CometmarksNotesHandler._local_notes_data[CometmarksNotesHandler._current_note_id].guid );
		document.getElementById("note_save_image").setAttribute("status", "disabled" );		
		document.getElementById("note_save_image").setAttribute("usable", "0" );
		var note_content = CometmarksNotesHandler._local_notes_data[CometmarksNotesHandler._current_note_id].value;
		if ( note_content.length > 0)
			document.getElementById("panel_note_text").value = note_content + "\r\n\r\n";
		else
			document.getElementById("panel_note_text").value = "";
			
		CometmarksNotesHandler.noteShowLabPannel();
	},

	noteEditTab : function( event )// db click
	{
		if ( event.button != 0 )// not left button
			return;
				
		if(event.target.id != this._current_label_tab)
			return;
		// show note-textbox
		if ( event.target.id == "label_note_1" )
		{
			var note_label_1 = document.getElementById("label_note_1");
			note_label_1.setAttribute( "hidden", "true" );

			document.getElementById("label_note_div1_11").setAttribute( "style", "margin-top: -4px;" );
			var note_box = document.getElementById("textbox_note_1");
			note_box.setAttribute( "hidden", "false" );
			note_box.setAttribute( "style", " -moz-appearance: none; border: none; text-align:center; color:black; background-color:transparent;" );
			note_box.value = CometmarksNotesHandler._local_notes_data[CometmarksNotesHandler._current_page_begin].title;
			this._last_note_title = CometmarksNotesHandler._local_notes_data[CometmarksNotesHandler._current_page_begin];
			note_box.select();						
			this._current_textbox_tab = "textbox_note_1";
		}
		
		if ( event.target.id == "label_note_2" )
		{
			var note_label_1 = document.getElementById("label_note_2");
			note_label_1.setAttribute( "hidden", "true" );

			document.getElementById("label_note_div2_11").setAttribute( "style", "margin-top: -4px;" );
			var note_box = document.getElementById("textbox_note_2");
			note_box.setAttribute( "hidden", "false" );
			note_box.setAttribute( "style", " -moz-appearance: none; border: none; text-align:center; color:black; background-color:transparent;" );
			note_box.value = CometmarksNotesHandler._local_notes_data[CometmarksNotesHandler._current_page_begin + 1].title;
			this._last_note_title = CometmarksNotesHandler._local_notes_data[CometmarksNotesHandler._current_page_begin + 1];
			note_box.select();						
			this._current_textbox_tab = "textbox_note_2";
		}
		
		if ( event.target.id == "label_note_3" )
		{
			var note_label_1 = document.getElementById("label_note_3");
			note_label_1.setAttribute( "hidden", "true" );

			document.getElementById("label_note_div3_11").setAttribute( "style", "margin-top: -4px;" );
			var note_box = document.getElementById("textbox_note_3");
			note_box.setAttribute( "hidden", "false" );
			note_box.setAttribute( "style", " -moz-appearance: none; border: none; text-align:center; color:black; background-color:transparent;" );
			note_box.value = CometmarksNotesHandler._local_notes_data[CometmarksNotesHandler._current_page_begin + 2].title;
			this._last_note_title = CometmarksNotesHandler._local_notes_data[CometmarksNotesHandler._current_page_begin + 2];
			note_box.select();						
			this._current_textbox_tab = "textbox_note_3";
		}
	},

	saveNoteTitle : function()
	{
		// hidden note-textbox
		var note_box = document.getElementById( this._current_textbox_tab );
		note_box.setAttribute( "hidden", "true" );
			
		// show note-label
		document.getElementById("label_note_div1_11").setAttribute( "style", "margin-top: 0px;" );
		document.getElementById("label_note_div2_11").setAttribute( "style", "margin-top: 0px;" );
		document.getElementById("label_note_div3_11").setAttribute( "style", "margin-top: 0px;" );
		document.getElementById( this._current_label_tab ).setAttribute( "value", note_box.value );
		document.getElementById( this._current_label_tab ).setAttribute( "hidden", "false" );
		document.getElementById( this._current_label_tab ).setAttribute( "style", "font-weight: bold; text-align:center;" );
		
		if ( this._last_note_title.title == note_box.value )
			return;
			
		this._last_note_title.title = note_box.value;
		
		// save and notify
		this.setLocalNotes( );
	},
	
	noteSave : function( event )
	{	
		if ( event.target.getAttribute("usable") != "1" )
			return;
			
		// save all notes
		var content = CometmarksNotesHandler.format(document.getElementById("panel_note_text").value);
		if(CometmarksNotesHandler._local_notes_data[CometmarksNotesHandler._current_note_id].value != content)
		{
			CometmarksNotesHandler._local_notes_data[CometmarksNotesHandler._current_note_id].value = content;
			this.setLocalNotes( );
		}	
		
		// reset note
		document.getElementById("panel_note_text").value = content + "\r\n\r\n";
		
		// save and notify
		
		document.getElementById("note_save_image").setAttribute("status", "disabled" );		
		document.getElementById("note_save_image").setAttribute("usable", "0" );
	},
	
	noteCut : function( event )
	{
		if ( event.button != 0 )// not left button
			return;
			
		if ( event.target.getAttribute("usable") != "1" )
			return;
			
		var aCommand = "cmd_cut";
		goDoCommand( aCommand );
		
		var controller = document.getElementById("panel_note_text").controllers.getControllerForCommand( aCommand );
		if( controller && controller.isCommandEnabled( aCommand ) ) 
		{
			document.getElementById("note_cut_image").setAttribute("status", "able" );
			document.getElementById("note_cut_image").setAttribute("usable", "1" );
		}
		else
		{
			document.getElementById("note_cut_image").setAttribute("status", "disabled" );
			document.getElementById("note_cut_image").setAttribute("usable", "0" );
		}
	},

	noteCopy : function( event )
	{
		if ( event.button != 0 )// not left button
			return;
			
		if ( event.target.getAttribute("usable") != "1" )
			return;
			
		var aCommand = "cmd_copy";
		goDoCommand( aCommand );
		
		var controller = document.getElementById("panel_note_text").controllers.getControllerForCommand( aCommand );
		if( controller && controller.isCommandEnabled( aCommand ) ) 
		{
			document.getElementById("note_copy_image").setAttribute("status", "able" );
			document.getElementById("note_copy_image").setAttribute("usable", "1" );
		}
		else
		{
			document.getElementById("note_copy_image").setAttribute("status", "disabled" );
			document.getElementById("note_copy_image").setAttribute("usable", "0" );
		}
	},

	notePaste : function( event )
	{
		if ( event.button != 0 )// not left button
			return;
			
		if ( event.target.getAttribute("usable") != "1" )
			return;
			
		var aCommand = "cmd_paste";
		goDoCommand( aCommand );
		
		var controller = document.getElementById("panel_note_text").controllers.getControllerForCommand( aCommand );
		if( controller && controller.isCommandEnabled( aCommand ) ) 
		{
			document.getElementById("note_paste_image").setAttribute("status", "able" );
			document.getElementById("note_paste_image").setAttribute("usable", "1" );
		}
		else
		{
			document.getElementById("note_paste_image").setAttribute("status", "disabled" );
			document.getElementById("note_paste_image").setAttribute("usable", "0" );
		}
	},
	
	noteNew : function( event, label_id )
	{
		CometmarksNotesHandler._current_note_id = CometmarksNotesHandler._current_page_begin + label_id;

		var bubble = Components.classes["@mozilla.org/intl/stringbundle;1"].getService(Components.interfaces.nsIStringBundleService).createBundle("chrome://cometmarks/locale/cometmarks.properties");
		var newnote_title = bubble.GetStringFromName("cometmarks.notes.newnote.title");
		var new_note_data = new Object();
		new_note_data.guid = CometMarksUtility.createGuid();
		new_note_data.type = "note";
		new_note_data.title = newnote_title;
		new_note_data.value = "";
		new_note_data.value = CometmarksNotesHandler.addTime(new_note_data.value);
		CometmarksNotesHandler._local_notes_data.splice(CometmarksNotesHandler._current_note_id, 0, new_note_data);
		CometmarksNotesHandler.noteSelectTab(null, CometmarksNotesHandler._current_note_id);		
		CometmarksNotesHandler.setLocalNotes();
	},
	
	noteDelete : function( event, label_id )
	{
		var delete_note_id = CometmarksNotesHandler._current_page_begin + label_id;

		CometmarksNotesHandler._local_notes_data.splice(delete_note_id, 1);
		if(CometmarksNotesHandler._current_page_begin >= CometmarksNotesHandler._local_notes_data.length && CometmarksNotesHandler._current_page_begin > 0)
			CometmarksNotesHandler._current_page_begin--;
		if(CometmarksNotesHandler._current_note_id > delete_note_id)
		{
			CometmarksNotesHandler._current_note_id--;
			CometmarksNotesHandler.noteShowLabPannel();
		}
		else if(CometmarksNotesHandler._current_note_id == delete_note_id)
		{
			if(CometmarksNotesHandler._current_note_id < CometmarksNotesHandler._local_notes_data.length)
				CometmarksNotesHandler.noteSelectTab(null, CometmarksNotesHandler._current_note_id);
			else if(CometmarksNotesHandler._current_note_id > 0)
			{
				CometmarksNotesHandler._current_note_id--;
				if(CometmarksNotesHandler._current_page_begin > 0)
					CometmarksNotesHandler._current_page_begin--;
				CometmarksNotesHandler.noteSelectTab(null, CometmarksNotesHandler._current_note_id);
			}
			else if(CometmarksNotesHandler._current_note_id == 0)
			{
				var bubble = Components.classes["@mozilla.org/intl/stringbundle;1"].getService(Components.interfaces.nsIStringBundleService).createBundle("chrome://cometmarks/locale/cometmarks.properties");
				var newnote_title = bubble.GetStringFromName("cometmarks.notes.newnote.title");
				var new_note_data = new Object();
				new_note_data.guid = CometMarksUtility.createGuid();
				new_note_data.type = "note";
				new_note_data.title = newnote_title;
				new_note_data.value = "";
				new_note_data.value = CometmarksNotesHandler.addTime(new_note_data.value);
				CometmarksNotesHandler._local_notes_data.push(new_note_data);
				CometmarksNotesHandler.noteSelectTab(null, CometmarksNotesHandler._current_note_id);
			}
		}
		else
		{
			CometmarksNotesHandler.noteShowLabPannel();
		}
		this.setLocalNotes( );
	},
	
	input : function( event )
	{
		if ( event.target.id != "panel_note_text" )
			return;
	
		document.getElementById("note_save_image").setAttribute("status", "able" );		
		document.getElementById("note_save_image").setAttribute("usable", "1" );	
	},
	
	keyup : function( obj )
	{
		var mlength = obj.getAttribute ? parseInt( obj.getAttribute("maxlength") ) : "";
		if ( obj.getAttribute && obj.value.length > mlength)
			obj.value = obj.value.substring( 0, mlength );
	},
	
	updateCut : function()
	{
		var aCommand = "cmd_cut";	
		var controller = document.getElementById("panel_note_text").controllers.getControllerForCommand( aCommand );
		if( controller && controller.isCommandEnabled( aCommand ) ) 
		{
			document.getElementById("note_cut_image").setAttribute("status", "able" );
			document.getElementById("note_cut_image").setAttribute("usable", "1" );
		}
		else
		{
			document.getElementById("note_cut_image").setAttribute("status", "disabled" );
			document.getElementById("note_cut_image").setAttribute("usable", "0" );
		}
	},

	updateCopy : function()
	{			
		var aCommand = "cmd_copy";
		var controller = document.getElementById("panel_note_text").controllers.getControllerForCommand( aCommand );
		if( controller && controller.isCommandEnabled( aCommand ) ) 
		{
			document.getElementById("note_copy_image").setAttribute("status", "able" );
			document.getElementById("note_copy_image").setAttribute("usable", "1" );
		}
		else
		{
			document.getElementById("note_copy_image").setAttribute("status", "disabled" );
			document.getElementById("note_copy_image").setAttribute("usable", "0" );
		}
	},
	
	updatePaste : function()
	{
		var aCommand = "cmd_paste";
		var controller = document.getElementById("panel_note_text").controllers.getControllerForCommand( aCommand );
		if( controller && controller.isCommandEnabled( aCommand ) ) 
		{
			document.getElementById("note_paste_image").setAttribute("status", "able" );
			document.getElementById("note_paste_image").setAttribute("usable", "1" );
		}
		else
		{
			document.getElementById("note_paste_image").setAttribute("status", "disabled" );
			document.getElementById("note_paste_image").setAttribute("usable", "0" );
		}
	},
	
	cometmarks_notes_move_left : function(event)
	{
		if( CometmarksNotesHandler._current_page_begin > 0)
		{
			CometmarksNotesHandler._current_page_begin--;
			CometmarksNotesHandler.noteShowLabPannel();
		}
	},
	
	cometmarks_notes_move_right : function(event)
	{
		if( CometmarksNotesHandler._current_page_begin + 1< CometmarksNotesHandler._local_notes_data.length)
		{
			CometmarksNotesHandler._current_page_begin++;
			CometmarksNotesHandler.noteShowLabPannel();
		}		
	},
	
	noteShowLabPannel : function()
	{
		for(var i=0; i<this._label_tab_list.length; ++i)
		{
			if(CometmarksNotesHandler._current_page_begin + i >= CometmarksNotesHandler._local_notes_data.length)
				break;
			
			if ( CometmarksNotesHandler._local_notes_data[CometmarksNotesHandler._current_page_begin + i].title.length > 0 )
			{
				document.getElementById(this._label_tab_list[i]).value = CometmarksNotesHandler._local_notes_data[CometmarksNotesHandler._current_page_begin + i].title;
			}
			else
			{
				document.getElementById(this._label_tab_list[i]).value = "Note";
				CometmarksNotesHandler._local_notes_data[CometmarksNotesHandler._current_page_begin + i].title = "Note";
			}
		}
		
		var selectlab;
		if(CometmarksNotesHandler._current_page_begin + 3 > CometmarksNotesHandler._current_note_id && CometmarksNotesHandler._current_note_id >= CometmarksNotesHandler._current_page_begin)
			selectlab = CometmarksNotesHandler._current_note_id - CometmarksNotesHandler._current_page_begin;
		if(selectlab != null && selectlab < this._label_tab_list.length)
			this._current_label_tab = this._label_tab_list[selectlab];
		else
			this._current_label_tab = null;
			
		if( selectlab == 0 )
		{
			document.getElementById("label_note_1").setAttribute( "style", "font-weight: bold; text-align:center;" );
			document.getElementById("note_bg_left1").setAttribute( "status", "show" );
			document.getElementById("label_note_div1_1").setAttribute( "style", "background-image: url('chrome://cometmarks/skin/buttons/notes-label-bg-center.png')" );
			document.getElementById("note_bg_right1").setAttribute( "status", "show");
			document.getElementById("note_bg_right1").setAttribute( "hidden", "false" );
			document.getElementById("label_note_div1").setAttribute( "style", "margin-top: -6px;" );
		}
		else
		{
			document.getElementById("label_note_1").setAttribute( "style", "font-weight: normal; text-align:center;" );
			document.getElementById("note_bg_left1").setAttribute( "status", "hide" );
			document.getElementById("label_note_div1_1").setAttribute( "style", "background-image:url('chrome://cometmarks/skin/buttons/notes-label-bg-center-replace.png')" );
			document.getElementById("note_bg_right1").setAttribute( "hidden", "false" );
			document.getElementById("note_bg_right1").setAttribute( "status", "hide" );
			document.getElementById("label_note_div1").setAttribute( "style", "margin-top: -5px;" );
		}
			
		if( selectlab == 1 )
		{
			document.getElementById("label_note_2").setAttribute( "style", "font-weight: bold; text-align:center;" );
			document.getElementById("note_bg_left2").setAttribute( "status", "show" );
			document.getElementById("note_bg_left2").setAttribute( "hidden", "false" );
			document.getElementById("label_note_div2_1").setAttribute( "style", "background-image:url('chrome://cometmarks/skin/buttons/notes-label-bg-center.png')" );
			document.getElementById("note_bg_right2").setAttribute( "hidden", "false" );
			document.getElementById("note_bg_right2").setAttribute( "status", "show" );
			document.getElementById("label_note_div2").setAttribute( "style", "margin-top: -6px;" );
		}
		else
		{
			document.getElementById("label_note_2").setAttribute( "style", "font-weight: normal; text-align:center;" );
			document.getElementById("note_bg_left2").setAttribute( "status", "hide" );
			document.getElementById("note_bg_left2").setAttribute( "hidden", "true" );
			document.getElementById("label_note_div2_1").setAttribute( "style", "background-image:url('chrome://cometmarks/skin/buttons/notes-label-bg-center-replace.png')" );
			document.getElementById("note_bg_right2").setAttribute( "hidden", "true" );
			document.getElementById("note_bg_right2").setAttribute( "status", "hide" );
			document.getElementById("label_note_div2").setAttribute( "style", "margin-top: -5px;" );
		}
			
		if( selectlab == 2 )
		{
			document.getElementById("label_note_3").setAttribute( "style", "font-weight: bold; text-align:center;" );
			document.getElementById("note_bg_left3").setAttribute( "hidden", "false" );
			document.getElementById("note_bg_left3").setAttribute( "status", "show" );
			document.getElementById("label_note_div3_1").setAttribute( "style", "background-image:url('chrome://cometmarks/skin/buttons/notes-label-bg-center.png')" );
			document.getElementById("note_bg_right3").setAttribute( "status", "show" );
			document.getElementById("label_note_div3").setAttribute( "style", "margin-top: -6px;" );
		}
		else
		{
			document.getElementById("label_note_3").setAttribute( "style", "font-weight: normal; text-align:center;" );
			document.getElementById("note_bg_left3").setAttribute( "hidden", "false" );
			document.getElementById("note_bg_left3").setAttribute( "status", "hide" );
			document.getElementById("label_note_div3_1").setAttribute( "style", "background-image:url('chrome://cometmarks/skin/buttons/notes-label-bg-center-replace.png')" );
			document.getElementById("note_bg_right3").setAttribute( "status", "hide" );
			document.getElementById("label_note_div3").setAttribute( "style", "margin-top: -5px;" );
		}

		if(CometmarksNotesHandler._current_page_begin + 2 > CometmarksNotesHandler._local_notes_data.length)
		{
			document.getElementById("label_note_2").setAttribute( "hidden", "true" );
			document.getElementById("label_menu_popup2").setAttribute( "hidden", "true" );
		}
		else
		{
			document.getElementById("label_note_2").setAttribute( "hidden", "false" );
			document.getElementById("label_menu_popup2").setAttribute( "hidden", "false" );
		}
		
		if(CometmarksNotesHandler._current_page_begin + 3 > CometmarksNotesHandler._local_notes_data.length)
		{
			document.getElementById("label_note_3").setAttribute( "hidden", "true" );
			document.getElementById("label_menu_popup3").setAttribute( "hidden", "true" );
		}
		else
		{
			document.getElementById("label_note_3").setAttribute( "hidden", "false" );
			document.getElementById("label_menu_popup3").setAttribute( "hidden", "false" );
		}

		if(CometmarksNotesHandler._current_page_begin == 0)
		{
			document.getElementById("note_left").setAttribute("status", "disabled");
		}
		else
		{
			document.getElementById("note_left").setAttribute("status", "able");
		}
		
		if(CometmarksNotesHandler._current_page_begin + 1 >=  CometmarksNotesHandler._local_notes_data.length)
		{
			document.getElementById("note_right").setAttribute("status", "disabled");
		}
		else
		{
			document.getElementById("note_right").setAttribute("status", "able");
		}
		
		document.getElementById("panel_note_text").focus();
	},
	
	format : function(content)
	{
		if(content == null)
			return null;
		content = content.replace(/\r/g, "");
		content = content.replace(/\n/g, "\r\n");
		content = content.replace(/\s+$/g, "");
		
		// note_content max length 1024
		if ( content.length > 10 * 1024 )
			content = content.substr(0, 10 * 1024);
		return content;
	},
	
	cloneNote : function(note_data)
	{
		var new_note = new Object();
		new_note.guid = note_data.guid;
		new_note.type = note_data.type;
		new_note.title = note_data.title;
		new_note.value = note_data.value;
		return new_note;
	},
	
	addTime : function(content)
	{
		var myDate = new Date();
		content = myDate.toLocaleString() + "\r\n" + content;
		return content;
	}
};

window.addEventListener( "load", CometmarksNotesHandler.init, false );
window.addEventListener( "unload", CometmarksNotesHandler.release, false );