﻿/* overwritedialog observer */
var CometmarksOverWriteObserver = 
{
	observe: function( subject, topic, data )
	{
		if ( topic == CometMarksKernelDefine.event_logout )
		{
			// to close the overwrite dialog
			CometmarksOverWriteHandler.closeOverwriteDialog( false );
		}
	}
};

/* deal with overwrite ui */
var CometmarksOverWriteHandler = 
{
	_is_closed_derectly	: false,
	
	init : function()
	{
		document.documentElement.setAttribute( "windowtype", "CometMarksOverwriteDialog" );
		CometmarksOverWriteHandler._is_closed_derectly = true;
		
		// add observer
		var observerService = Components.classes["@mozilla.org/observer-service;1"].getService(Components.interfaces.nsIObserverService);
		observerService.addObserver( CometmarksOverWriteObserver, CometMarksKernelDefine.event_logout, false );
	},
	
	mergeAllBookmarks : function()
	{
		write_log( "select mergeAllBookmarks method" );
		
		CometMarksKernel.merge();
		CometMarksKernel.mergeSpecial();
		
		// notify to recover bookmarks
		var bserverService = Components.classes["@mozilla.org/observer-service;1"].getService(Components.interfaces.nsIObserverService);
		bserverService.notifyObservers( null, CometMarksBookMarksDefine.event_bookmarks_recover, null );
		
		// next time sync
		var minimum_sync_interval_sec = CometMarksUtility.getMinimumSyncIntervalSec();
		CometMarksUtility.setNextSyncTime( minimum_sync_interval_sec );
		
		// notify ui
		CometMarksKernel.bookmarksChanged();
		
		CometmarksOverWriteHandler.closeOverwriteDialog( false );
	},
	
	overwriteLocal : function()
	{
		write_log( "select overwriteLocal method" );
		CometMarksKernel.mergeSpecial();
		
		// notify to recover bookmarks
		var bserverService = Components.classes["@mozilla.org/observer-service;1"].getService(Components.interfaces.nsIObserverService);
		bserverService.notifyObservers( null, CometMarksBookMarksDefine.event_bookmarks_recover, null );
		
		// set next time sync
		var autosync_interval_sec = CometMarksUtility.getAutosyncIntervalSec();
		CometMarksUtility.setNextSyncTime( autosync_interval_sec );
		
		CometmarksOverWriteHandler.closeOverwriteDialog( false );
	},
	
	overwriteRemote : function()
	{
		write_log("select overwriteRemote method");
		CometMarksKernel.commit();
		CometmarksOverWriteHandler.closeOverwriteDialog( false );
	},
	
	// if close_mode is true: close the dialog and logout the account
	// if close_mode is false: only close the dialog
	closeOverwriteDialog : function( close_mode )
	{
		// remove the observer
		var observerService = Components.classes["@mozilla.org/observer-service;1"].getService(Components.interfaces.nsIObserverService);
		observerService.removeObserver( CometmarksOverWriteObserver, CometMarksKernelDefine.event_logout );
		
		if ( close_mode )
		{
			CometMarksKernel.logOut();
		}
		
		CometmarksOverWriteHandler._is_closed_derectly = false;
		window.close();
	},
	
	onCancel : function()
	{
		if ( CometmarksOverWriteHandler._is_closed_derectly )
			CometmarksOverWriteHandler.closeOverwriteDialog( true );
	}
};

window.addEventListener("load", CometmarksOverWriteHandler.init, false);
window.addEventListener("unload", CometmarksOverWriteHandler.onCancel, false);