﻿// 彗星书签事务处理
// 多个FireFox窗口中只有，一个窗口负责处理事务，
// 提供事务控制权的转换

/* 常量定义 */

if( typeof( CometMarksRoutineDefine ) == "undefined" )
{
	try
	{
		eval('																		\r\n\
			const CometMarksRoutineDefine = {										\r\n\
				/* 事件定义 */														\r\n\
				// 具有事务控制权的窗口被关闭										\r\n\
				event_devolution : "cometmarks.routine.event.devolution"			\r\n\
			};																		\r\n\
		');
	} catch( e ) { }
}

var CometMarksRoutine = {
	/* 功能函数 */
	// 检查是否要用事务控制权
	isHasPrivilege : function()
	{
		var application	= Components.classes["@mozilla.org/fuel/application;1"].getService( Components.interfaces.fuelIApplication );
		var obj = Application.storage.get( "cometmarks_routine_object", null );
		
		return CometMarksRoutineObserver == obj;
	}
};

//////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
// 实现代码, 以下代码和定义不得在其它模块使用

/* 常量定义 */

if( typeof( CometMarksRoutineImplDefine ) == "undefined" )
{
	try
	{
		eval('																		\r\n\
			const CometMarksRoutineImplDefine = {									\r\n\
				/* 事件定义 */														\r\n\
				// 具有事务控制权的窗口被关闭										\r\n\
				event_devolution : "cometmarks.routine.event.impl_devolution"		\r\n\
			};																		\r\n\
		');
	} catch( e ) { }
}

var CometMarksRoutineObserver = new function()
{
	this.observe = function( subject, topic, data )
	{
		if ( topic == CometMarksRoutineImplDefine.event_devolution )
		{
			// 事务控制权发生改变
			var application	= Components.classes["@mozilla.org/fuel/application;1"].getService( Components.interfaces.fuelIApplication );
			var obj 		= Application.storage.get( "cometmarks_routine_object", null );

			if( obj == null )
			{
				application.storage.set( "cometmarks_routine_object", this );

				var _observer_service 	= Components.classes["@mozilla.org/observer-service;1"].getService( Components.interfaces.nsIObserverService );
				_observer_service.notifyObservers( null, CometMarksRoutineDefine.event_devolution, null );
			}
		}
	};

	this.register = function()
	{
		var _observer_service 	= Components.classes["@mozilla.org/observer-service;1"].getService( Components.interfaces.nsIObserverService );
		_observer_service.addObserver( this, CometMarksRoutineImplDefine.event_devolution, false );
	}; 

	this.unregister = function()
	{
		var _observer_service 	= Components.classes["@mozilla.org/observer-service;1"].getService( Components.interfaces.nsIObserverService );
		_observer_service.removeObserver( this, CometMarksRoutineImplDefine.event_devolution );
	};

};

var CometMarksRoutineImpl = {

	/* 功能函数 */
	// 初始化
	init : function()
	{	
		CometMarksRoutineObserver.register();

		var application	= Components.classes["@mozilla.org/fuel/application;1"].getService( Components.interfaces.fuelIApplication );
		var obj 		= Application.storage.get( "cometmarks_routine_object", null );
		if( obj == null )
		{
			application.storage.set( "cometmarks_routine_object", CometMarksRoutineObserver );

			var _observer_service 	= Components.classes["@mozilla.org/observer-service;1"].getService( Components.interfaces.nsIObserverService );
			_observer_service.notifyObservers( null, CometMarksRoutineDefine.event_devolution, null );
		}
	},

	// 析构
	release : function()
	{
		CometMarksRoutineObserver.unregister();

		var application	= Components.classes["@mozilla.org/fuel/application;1"].getService( Components.interfaces.fuelIApplication );
		var obj 		= Application.storage.get( "cometmarks_routine_object", null );
		
		if( CometMarksRoutineObserver == obj )
		{
			application.storage.set( "cometmarks_routine_object", null );
	
			// 通知其它窗口
			var _observer_service 	= Components.classes["@mozilla.org/observer-service;1"].getService( Components.interfaces.nsIObserverService );
			_observer_service.notifyObservers( null, CometMarksRoutineImplDefine.event_devolution, null );
		}
	},
};

window.addEventListener( "load", CometMarksRoutineImpl.init, false );
window.addEventListener( "unload", CometMarksRoutineImpl.release, false );