﻿/* define cometmarks global const variables */
if( typeof( CometMarksGlobalDefine ) == "undefined" )
{
	try
	{
		eval('																					\r\n\
			const CometMarksGlobalDefine =														\r\n\
			{																					\r\n\
				last_failed_time			:	"cometmarks.global.last_failed_time",			\r\n\
				last_sync_time			:	"cometmarks.global.last_sync_time",					\r\n\
				next_sync_time			:	"cometmarks.global.next_sync_time",					\r\n\
				current_tab_guid		:	"cometmarks.global.current_tab_guid",				\r\n\
				is_bookmarks_changeded	:	"cometmarks.global.is_bookmarks_changeded",			\r\n\
				is_close_overwrite		:	"cometmarks.global.is_close_overwrite",				\r\n\
				current_note_guid		:	"cometmarks.global.current_note_guid",				\r\n\
				current_note_content	:	"cometmarks.global.current_note_content"			\r\n\
			};																					\r\n\
		');
	} 
	catch( e ) 
	{
		alert ( e ); 
	}
}

/* CometMarksGlobal class */
var CometMarksGlobal = 
{
	getGlobalData : function()
	{
		var globalData = new Object();
		var Application = Components.classes["@mozilla.org/fuel/application;1"].getService(Components.interfaces.fuelIApplication);

		globalData.last_failed_time = Application.storage.get( CometMarksGlobalDefine.last_failed_time, null);					// 上次登陆时间
		globalData.last_sync_time = Application.storage.get( CometMarksGlobalDefine.last_sync_time, null);					// 上次同步时间
		globalData.next_sync_time = Application.storage.get( CometMarksGlobalDefine.next_sync_time, null);					// 下次同步时间
		globalData.current_tab_guid = Application.storage.get( CometMarksGlobalDefine.current_tab_guid, null);				// 当前的 tab guid
		
		globalData.is_bookmarks_changeded = Application.storage.get( CometMarksGlobalDefine.is_bookmarks_changeded, null);	// 书签是否发生变化
		globalData.is_close_overwrite = Application.storage.get( CometMarksGlobalDefine.is_close_overwrite, null);			// 是否直接关闭书签选择对话框
		
		globalData.current_note_guid = Application.storage.get( CometMarksGlobalDefine.current_note_guid, null);			// note 当前 guid
		globalData.current_note_content = Application.storage.get( CometMarksGlobalDefine.current_note_content, null);		// note 当前内容
		
		return globalData;
	},

	setData : function( key, value )
	{
		var Application = Components.classes["@mozilla.org/fuel/application;1"].getService(Components.interfaces.fuelIApplication);
		Application.storage.set( key, value );
	}
};

/*  utility funciton */
var CometMarksUtility = 
{
	formatGmtTime : function( gmt_time )
	{
		if ( gmt_time == "N/A" || gmt_time == null )
			return "N/A";
		
		var time = new Date(gmt_time);
		var format_time = time.getFullYear() + "-";
		
		var month = time.getMonth() + 1;
		if (month < 10)
			format_time += "0";
		format_time = format_time + month.toString() + "-"; 
		
		var date = time.getDate();
		if (date < 10)
			format_time += "0";
		format_time = format_time + date.toString() + " ";
		
		var hour = time.getHours();
		if (hour < 10)
			format_time += "0";
		format_time = format_time + hour.toString() + ":"; 
		
		var minute = time.getMinutes();
		if (minute < 10)
			format_time += "0";
		format_time = format_time + minute.toString() + ":";

		var second = time.getSeconds();
		if (second < 10)
			format_time += "0";
		format_time = format_time + second.toString();
		 
		return format_time; // format: 2009-04-15 10:34:22
	},
	
	getSecondsFromTimeStr : function( time_str )
	{
		if ( time_str == "N/A" )
			return 0;

		var now = new Date( time_str );
		var seconds = now.getSeconds();
		seconds += now.getMinutes() * 60;
		return seconds;
	},
	
	openURL : function( url )
	{
		var wm = Components.classes["@mozilla.org/appshell/window-mediator;1"].getService(Components.interfaces.nsIWindowMediator);
		var mainWindow = wm.getMostRecentWindow("navigator:browser");
		var gBrowser = mainWindow.getBrowser();
		
		var currentTab = gBrowser.getBrowserAtIndex( gBrowser.mTabContainer.selectedIndex );
		if ( currentTab.currentURI.spec == "about:blank" )// current tab
		{		
			gBrowser.loadURI( url, null, null );	
			return;
		}
		
		var browserEnumerator = wm.getEnumerator( "navigator:browser" );
		var browserWin = browserEnumerator.getNext();
		var tabbrowser = browserWin.getBrowser();

		var index = tabbrowser.browsers.length - 1;
		var lastBrowser = tabbrowser.getBrowserAtIndex( index );
		if ( lastBrowser.currentURI.spec == "about:blank" )
		{
			tabbrowser.selectedTab = tabbrowser.mTabs[index];	
			gBrowser.loadURI( url, null, null );
		}
		else
		{	
			tabbrowser.selectedTab = gBrowser.addTab( url, null, null );
		}
	},
	
	getCometMarksSettingDialog : function()
	{
		var setting_win = this.getWindowByType( "CometMarksSettingDialog" );
		if ( setting_win == null || setting_win.closed )
		{
			setting_win = window.open( "chrome://cometmarks/content/cometmarks_setting.xul", "CometMarks Setting...", "chrome,titlebar,toolbar=yes,centerscreen" );
		}		
		else
			setting_win.focus();
	},
	
	getCometMarksLogout : function()
	{
		// remove username
		CometPassport.clear();
		
		// logout
		CometMarksKernel.logOut();
		write_log("cometmarks logout!");
	},
	
	getWindowByType : function( winType )
	{
		var windowsMediator = Components.classes["@mozilla.org/appshell/window-mediator;1"].getService(Components.interfaces.nsIWindowMediator);
		var win = windowsMediator.getMostRecentWindow( winType );
		return win;
	},
	
	getAutosyncIntervalSec : function()
	{
		var ps = Components.classes["@mozilla.org/preferences-service;1"].getService(Components.interfaces.nsIPrefService);       
		var prefs = ps.getBranch("cometmarks.");
		var	time_seconds = prefs.getIntPref( "autosync_interval_sec" );
		
		return time_seconds;
	},

	getMinimumSyncIntervalSec : function()
	{
		var ps = Components.classes["@mozilla.org/preferences-service;1"].getService(Components.interfaces.nsIPrefService);       
		var prefs = ps.getBranch("cometmarks.");
		var time_seconds = prefs.getIntPref( "minimum_sync_interval_sec" );
	  
		return time_seconds;
	},
	
	showErrorMessage : function()
	{
		// show error message
		var bubble = Components.classes["@mozilla.org/intl/stringbundle;1"].getService(Components.interfaces.nsIStringBundleService).createBundle( "chrome://cometmarks/locale/cometmarks.properties" );
		var message = bubble.GetStringFromName( "cometmarks.operate.failed" );
		write_log( message );
	},

	createGuid : function()
	{
		var guid = "";
		for ( var i = 1; i <= 32; i++ )
		{
			var n = Math.floor( Math.random()*16.0 ).toString(16);
			guid += n;
			if( (i==8) || (i==12) || (i==16) || (i==20) )
			guid += "-";
		}
		return guid;    
	},
		
	getCurrentTime : function()
	{
		var a = new Date();  
		//var y = a.getYear()+"-";  
		//var m = a.getMonth()+"-";  
		//var d = a.getDay()+"-";  
		var h = a.getHours()+"-";  
		var x = a.getMinutes()+"-";  
		var s = a.getSeconds()+": ";  
		var ms = a.getMilliseconds();  
  
		return h + x + s + ms;
	},
	
	setNextSyncTime : function( interval_time )
	{
		// no login or logout
		if ( interval_time == "N/A" )
		{
			CometMarksGlobal.setData( CometMarksGlobalDefine.next_sync_time, "N/A" ); 
			return;
		}
		
		var now = new Date();
		now.setSeconds( now.getSeconds() + interval_time );
		CometMarksGlobal.setData( CometMarksGlobalDefine.next_sync_time, now.toGMTString() ); 
		write_log( "cometmarks next sync time: " + CometMarksUtility.formatGmtTime( now ) );
	},
	
	// open manage web page of bookmarks
	manageBookmarks : function()
	{
		var bubble = Components.classes["@mozilla.org/intl/stringbundle;1"].getService(Components.interfaces.nsIStringBundleService).createBundle("chrome://cometmarks/locale/cometmarks.properties");
		var url = bubble.GetStringFromName("cometmarks.atcomet.url");
		// get username  
		var user_name = CometPassport.getUsername();
		url = url + "&u=" + user_name;
		CometMarksUtility.openURL( url );
	},
	
	// bookmarks sync 
	synchronizeNow : function()
	{
	try{
		// to check overwrite dialog
		var overwrite_win = CometMarksUtility.getWindowByType( "CometMarksOverwriteDialog" );
		if ( overwrite_win )// has opened
		{
			overwrite_win.focus();
			return;
		}
		
		// if login, sync now
		var kernelState = CometMarksKernel.getState();
		if ( kernelState.is_login )
		{
			// go to sync
			CometMarksKernel.synchronize();
			return;
		}
		
		// get username and password from cometpassport
		var g_username = CometPassport.getUsername();
		var g_password = CometPassport.getPassword();
		if ( g_username != "" && g_password != "" )
		{
			// set passport username
			CometPassport.setUsername( g_username, g_password );
			return;
		}
		
		// to select the setting dialog
		var setting_win = CometMarksUtility.getWindowByType( "CometMarksSettingDialog" );
		if ( setting_win )// has opened
		{
			setting_win.focus();
			
			if ( setting_win.document.getElementById("general_password_editbox").value ) // password is empty
				setting_win.document.getElementById("general_password_editbox").select();
				
			if ( setting_win.document.getElementById("general_username_editbox").value ) // username is empty
				setting_win.document.getElementById("general_username_editbox").select();
			
			return;
		}
		
		// to open the setting dialog
		window.open( "chrome://cometmarks/content/cometmarks_setting.xul", "CometMarks Setting...", "chrome,titlebar,toolbar=yes,centerscreen" );
	}catch(e){ CometMarksUtility.showCatchMessage( e ); }
	},
	
	showCatchMessage : function ( message )
	{
		write_log( message );
	}
};

//////////////////////////////////////////////////////////////
/* utility observer */
var CometMarksUtilityObserver = 
{
	observe: function( subject, topic, data )
	{
	try{	
		if ( !CometMarksRoutine.isHasPrivilege() ) // do nothing
			return;
			
		// get kernel state
		var kernelState = CometMarksKernel.getState();
		var workState = kernelState.work_state;
		if ( workState == CometMarksKernelDefine.work_state_syncing ) // syncing
			return;

		// get value from pref.js, default is 5 * 60
		var autosync_interval_sec = CometMarksUtility.getAutosyncIntervalSec();
		
		switch( topic )
		{
			case CometMarksKernelDefine.event_update :

				// connect failed
				if ( kernelState.work_state == CometMarksKernelDefine.work_state_connect_failed )
				{
					write_log( "cometmarks update: failed!" );
					CometMarksUtility.setNextSyncTime( autosync_interval_sec );
					return;
				}
				
				// not success or no-record state
				if ( kernelState.work_state != CometMarksKernelDefine.work_state_success && kernelState.work_state != CometMarksKernelDefine.work_state_no_record )
					return;
				
				// bookmraks content mergespecial 
				CometMarksKernel.mergeSpecial();
				
				// get server bookmarks content
				var server_bookmarks_content = CometMarksKernel.getBookmarksContent();
				
				// bookmarks is empty
				if ( server_bookmarks_content == "" ) 
				{
					write_log( "update: server bookmarks content is null" );
					CometMarksUtility.setNextSyncTime( autosync_interval_sec );
					return;
				}

				this._local_revision = kernelState.bookmarks_version;
				write_log( "cometmarks current revision: " + this._local_revision + "\n" );
							
				// bookmarks is equal
				if ( CometMarksKernel.cometmarksEqual() )
				{
					write_log("local and server's bookmarks content are the same");
					CometMarksUtility.setNextSyncTime( autosync_interval_sec );
					return;
				}
				
				// open overwrite dialog
				window.openDialog( "chrome://cometmarks/content/cometmarks_overwrite_dialog.xul", "", "resizable=no,modal" );
				
				break;
				
			case CometMarksKernelDefine.event_sync :
				
				// connect failed
				if ( kernelState.work_state == CometMarksKernelDefine.work_state_connect_failed )
				{
					write_log( "cometmarks sync: failed!" );
					CometMarksUtility.setNextSyncTime( autosync_interval_sec );
					return;
				}
				
				// not success or no-record
				if ( kernelState.work_state != CometMarksKernelDefine.work_state_success && kernelState.work_state != CometMarksKernelDefine.work_state_no_record )
					return;
				
				// bookmraks content mergespecial 
				CometMarksKernel.mergeSpecial();
				
				// get server bookmarks content
				var server_bookmarks_content = CometMarksKernel.getBookmarksContent();
				
				// bookmarks is empty
				if ( server_bookmarks_content == "" ) 
				{
					write_log( "sync: server bookmarks content is null" );
					CometMarksUtility.setNextSyncTime( autosync_interval_sec );
					return;
				}

				var server_revision = kernelState.bookmarks_version;
				write_log( "cometmarks current revision: " + server_revision + "\n" );
				if ( this._local_revision == server_revision )
				{
					CometMarksUtility.setNextSyncTime( autosync_interval_sec );
					return;
				}
				
				// bookmarks is un-equal
				if ( !CometMarksKernel.cometmarksEqual() )
				{
					// notify to recover bookmarks
					var bserverService = Components.classes["@mozilla.org/observer-service;1"].getService(Components.interfaces.nsIObserverService);
					bserverService.notifyObservers( null, CometMarksBookMarksDefine.event_bookmarks_recover, null );
					write_log("sync: cometmarks recover completely");
				}
						
				this._local_revision = server_revision;
				CometMarksUtility.setNextSyncTime( autosync_interval_sec );
					
				break;
				
			case CometMarksKernelDefine.event_overwrite :

				if ( kernelState.work_state == CometMarksKernelDefine.work_state_success || kernelState.work_state == CometMarksKernelDefine.work_state_no_record )
				{
					this._local_revision = kernelState.bookmarks_version;
					CometMarksUtility.setNextSyncTime( autosync_interval_sec );
				}
				else
				{
					// merge faild, exit
					write_log("cometmarks overwrite failed");
				
					// logout
					CometMarksKernel.logOut();
					CometMarksUtility.showErrorMessage();
				}
				
				break;
				
			default :
				break;
		}
	}catch(e){ CometMarksUtility.showCatchMessage( e ); }
	},
	
	register : function()
	{
		if ( !CometMarksRoutine.isHasPrivilege() ) // do nothing
			return;
			
		var observer_service = Components.classes["@mozilla.org/observer-service;1"].getService( Components.interfaces.nsIObserverService );
		observer_service.addObserver( CometMarksUtilityObserver, CometMarksKernelDefine.event_update, false );
		observer_service.addObserver( CometMarksUtilityObserver, CometMarksKernelDefine.event_sync, false );
		observer_service.addObserver( CometMarksUtilityObserver, CometMarksKernelDefine.event_overwrite, false );
		
		// add observer
		ExtensionObserver.register();
	},
	
	unRegister : function()
	{
		if ( !CometMarksRoutine.isHasPrivilege() ) // do nothing
			return;
			
		var observer_service = Components.classes["@mozilla.org/observer-service;1"].getService( Components.interfaces.nsIObserverService );
		observer_service.removeObserver( CometMarksUtilityObserver, CometMarksKernelDefine.event_update );
		observer_service.removeObserver( CometMarksUtilityObserver, CometMarksKernelDefine.event_sync );
		observer_service.removeObserver( CometMarksUtilityObserver, CometMarksKernelDefine.event_overwrite );
		
		// remove observer
		ExtensionObserver.register();
	}
};

//////////////////////////////////////////////////////////////////
// deal with uninstall extension
var ExtensionObserver = 
{
	_uninstall : false,

	observe : function(subject, topic, data)
	{
		if ( topic == "em-action-requested" )
		{ 
			subject.QueryInterface(Components.interfaces.nsIUpdateItem);
			if( subject.id == "bookmarks@cometmarks.com" )
			{
				if ( data == "item-uninstalled" )
				{
					this._uninstall = true;
				}
				
				if ( data == "item-cancel-action" )
				{
					this._uninstall = false;
				}
			}
		}
		else if ( topic == "quit-application-granted" )
		{
			if ( this._uninstall )
			{
				// clean the data of extension
				cometmarks.CleanTempData();
				delete_log();
						
				// clean the data of cometmarks extension in prefs.js		
				var ps = Components.classes["@mozilla.org/preferences-service;1"].getService(Components.interfaces.nsIPrefService);      
				var prefs = ps.getBranch("cometmarks.");
				prefs.deleteBranch("");// delete all value of cometmarks
				
				// clear the data of comte passport
				CometPassport.clear();
			}
			
			this.unregister();
		}
	 },
	 
	register : function()
	{
		var observerService = Components.classes["@mozilla.org/observer-service;1"].getService(Components.interfaces.nsIObserverService);
		observerService.addObserver(this, "em-action-requested", false);
		observerService.addObserver(this, "quit-application-granted", false);
 	},
 	
 	unregister : function()
 	{
		var observerService = Components.classes["@mozilla.org/observer-service;1"].getService(Components.interfaces.nsIObserverService);
		observerService.removeObserver(this,"em-action-requested");
		observerService.removeObserver(this,"quit-application-granted");
 	}
};

window.addEventListener( "load", CometMarksUtilityObserver.register, false );
window.addEventListener( "unload", CometMarksUtilityObserver.unRegister, false );